#ifndef _H_1B40F862599828CD11D74E4C4FA5337E_VelodynePacket_DCPS_H_
#define _H_1B40F862599828CD11D74E4C4FA5337E_VelodynePacket_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VelodynePacket_.h"


namespace velodyne_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VelodynePacket_TypeSupportInterface;

            typedef VelodynePacket_TypeSupportInterface * VelodynePacket_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VelodynePacket_TypeSupportInterface> VelodynePacket_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VelodynePacket_TypeSupportInterface> VelodynePacket_TypeSupportInterface_out;


            class VelodynePacket_DataWriter;

            typedef VelodynePacket_DataWriter * VelodynePacket_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VelodynePacket_DataWriter> VelodynePacket_DataWriter_var;
            typedef DDS_DCPSInterface_out < VelodynePacket_DataWriter> VelodynePacket_DataWriter_out;


            class VelodynePacket_DataReader;

            typedef VelodynePacket_DataReader * VelodynePacket_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VelodynePacket_DataReader> VelodynePacket_DataReader_var;
            typedef DDS_DCPSInterface_out < VelodynePacket_DataReader> VelodynePacket_DataReader_out;


            class VelodynePacket_DataReaderView;

            typedef VelodynePacket_DataReaderView * VelodynePacket_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VelodynePacket_DataReaderView> VelodynePacket_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VelodynePacket_DataReaderView> VelodynePacket_DataReaderView_out;

            struct VelodynePacket_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VelodynePacket_, struct VelodynePacket_Seq_uniq_> VelodynePacket_Seq;
            typedef DDS_DCPSSequence_var < VelodynePacket_Seq> VelodynePacket_Seq_var;
            typedef DDS_DCPSSequence_out < VelodynePacket_Seq> VelodynePacket_Seq_out;

            class  VelodynePacket_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VelodynePacket_TypeSupportInterface_ptr _ptr_type;
                typedef VelodynePacket_TypeSupportInterface_var _var_type;

                static VelodynePacket_TypeSupportInterface_ptr _duplicate (VelodynePacket_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelodynePacket_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VelodynePacket_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelodynePacket_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VelodynePacket_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VelodynePacket_TypeSupportInterface () {};
                ~VelodynePacket_TypeSupportInterface () {};
            private:
                VelodynePacket_TypeSupportInterface (const VelodynePacket_TypeSupportInterface &);
                VelodynePacket_TypeSupportInterface & operator = (const VelodynePacket_TypeSupportInterface &);
            };

            class  VelodynePacket_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VelodynePacket_DataWriter_ptr _ptr_type;
                typedef VelodynePacket_DataWriter_var _var_type;

                static VelodynePacket_DataWriter_ptr _duplicate (VelodynePacket_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelodynePacket_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VelodynePacket_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelodynePacket_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VelodynePacket_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VelodynePacket_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VelodynePacket_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VelodynePacket_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VelodynePacket_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VelodynePacket_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VelodynePacket_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VelodynePacket_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VelodynePacket_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VelodynePacket_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VelodynePacket_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VelodynePacket_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VelodynePacket_& instance_data) = 0;

            protected:
                VelodynePacket_DataWriter () {};
                ~VelodynePacket_DataWriter () {};
            private:
                VelodynePacket_DataWriter (const VelodynePacket_DataWriter &);
                VelodynePacket_DataWriter & operator = (const VelodynePacket_DataWriter &);
            };

            class  VelodynePacket_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VelodynePacket_DataReader_ptr _ptr_type;
                typedef VelodynePacket_DataReader_var _var_type;

                static VelodynePacket_DataReader_ptr _duplicate (VelodynePacket_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelodynePacket_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VelodynePacket_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelodynePacket_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VelodynePacket_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VelodynePacket_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VelodynePacket_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VelodynePacket_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VelodynePacket_& instance) = 0;

            protected:
                VelodynePacket_DataReader () {};
                ~VelodynePacket_DataReader () {};
            private:
                VelodynePacket_DataReader (const VelodynePacket_DataReader &);
                VelodynePacket_DataReader & operator = (const VelodynePacket_DataReader &);
            };

            class  VelodynePacket_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VelodynePacket_DataReaderView_ptr _ptr_type;
                typedef VelodynePacket_DataReaderView_var _var_type;

                static VelodynePacket_DataReaderView_ptr _duplicate (VelodynePacket_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelodynePacket_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VelodynePacket_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelodynePacket_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VelodynePacket_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VelodynePacket_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VelodynePacket_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VelodynePacket_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VelodynePacket_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VelodynePacket_& instance) = 0;

            protected:
                VelodynePacket_DataReaderView () {};
                ~VelodynePacket_DataReaderView () {};
            private:
                VelodynePacket_DataReaderView (const VelodynePacket_DataReaderView &);
                VelodynePacket_DataReaderView & operator = (const VelodynePacket_DataReaderView &);
            };
        }

    }

}

#endif
